SystemOrganization addCategory: #'EjerciciosPoo-Measure'!

Interval subclass: #IntervalOfMeasure
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'EjerciciosPoo-Measure'!

!IntervalOfMeasure methodsFor: 'as yet unclassified' stamp: 'GabrielBursztyn 6/3/2012 23:38'!
last
	^stop.! !

!IntervalOfMeasure methodsFor: 'as yet unclassified' stamp: 'GabrielBursztyn 6/3/2012 23:46'!
size
	"Answer how many elements the receiver contains."
	
	(step amount) < 0 
		ifTrue: [start < stop
				ifTrue: [^ 0]
				ifFalse: [^ (stop - start) amount // (step amount) + 1]]
		ifFalse: [stop < start
				ifTrue: [^ 0 ]
				ifFalse: [^  (stop - start) amount // (step amount) + 1]]! !

Magnitude subclass: #Measure
	instanceVariableNames: 'unit amount'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'EjerciciosPoo-Measure'!

!Measure class methodsFor: 'as yet unclassified' stamp: 'Satelier 6/2/2012 13:29'!
newWith: aValue unit: aUnit
	^self new initializeWith: aValue unit: aUnit! !

!Measure methodsFor: 'as yet unclassified' stamp: 'GabrielBursztyn 6/5/2012 12:06'!
* anObject
	 anObject isNumber 
			ifTrue: [^Measure newWith: (amount *anObject) unit: unit]
			ifFalse: [
				| newUnit newAmount |
				newUnit := unit * anObject unit.
				newAmount := amount *anObject amount.
				(newUnit isEmpty) ifTrue: [^newAmount] ifFalse: [^Measure newWith: newAmount unit: newUnit].].
				
				
	
! !

!Measure methodsFor: 'as yet unclassified' stamp: 'GabrielBursztyn 6/5/2012 12:19'!
+ anObject
	| aMeasureOfSameUnit |
	 (anObject isNumber) 
			ifTrue: [^Measure newWith: (amount +anObject) unit: unit]
			ifFalse:  [aMeasureOfSameUnit := anObject convertTo: unit.
								^Measure newWith: amount + (aMeasureOfSameUnit amount)  unit: unit. ] .
											
										
"on: [Error ] do: [CanNotConvertMeasurementException signal ]]"! !

!Measure methodsFor: 'as yet unclassified' stamp: 'Satelier 6/3/2012 15:46'!
- aMeasure
	^self + aMeasure negated.
! !

!Measure methodsFor: 'as yet unclassified' stamp: 'GabrielBursztyn 6/5/2012 12:07'!
/ anObject
	 anObject isNumber 
			ifTrue: [^Measure newWith: (amount /anObject) unit: unit]
			
			ifFalse: [	
				| newUnit newAmount |
				newUnit := unit / anObject unit.
				newAmount := amount /anObject amount.
				(newUnit isEmpty) ifTrue: [^newAmount] ifFalse: [^Measure newWith: newAmount unit: newUnit].].
			
			

! !

!Measure methodsFor: 'as yet unclassified' stamp: 'GabrielBursztyn 6/4/2012 16:36'!
< aDistance
	^((self convertToBaseUnit)  < aDistance convertToBaseUnit).
! !

!Measure methodsFor: 'as yet unclassified' stamp: 'GabrielBursztyn 6/4/2012 16:47'!
= aMeasure				
^	(aMeasure isKindOf: self class) and: [
							(self convertToBaseUnit = aMeasure convertToBaseUnit).].! !

!Measure methodsFor: 'as yet unclassified' stamp: 'Satelier 6/3/2012 16:47'!
adaptToInteger: anInteger andSend: selector
	^self perform: selector with: anInteger! !

!Measure methodsFor: 'as yet unclassified' stamp: 'GabrielBursztyn 5/22/2012 00:57'!
amount
	^amount.! !

!Measure methodsFor: 'accessing' stamp: 'GabrielBursztyn 6/4/2012 16:39'!
convertTo: aMeasureUnit 
	((self unit type = aMeasureUnit type) not ) ifTrue: [^CanNotConvertMeasurementException signal .]
									 ifFalse: [^aMeasureUnit convert: self amount from: (self unit).]
! !

!Measure methodsFor: 'as yet unclassified' stamp: 'GabrielBursztyn 6/4/2012 20:52'!
convertToBaseUnit
	^unit convertToBaseUnit: amount.! !

!Measure methodsFor: 'as yet unclassified' stamp: 'GabrielBursztyn 6/4/2012 16:36'!
hash
 	^self convertToBaseUnit hash.! !

!Measure methodsFor: 'as yet unclassified' stamp: 'GabrielBursztyn 5/22/2012 00:57'!
initializeWith: aValue unit: aDistanceUnit
	amount:=aValue.
	unit:=aDistanceUnit.! !

!Measure methodsFor: 'as yet unclassified' stamp: 'Satelier 6/3/2012 15:45'!
negated
	^Measure newWith:  amount * (-1)  unit: unit.! !

!Measure methodsFor: 'as yet unclassified' stamp: 'GabrielBursztyn 5/22/2012 01:10'!
printOn: aStream
	aStream print: amount;
			 nextPutAll: ' '.
      unit printOn: aStream.
      (amount>1) ifTrue:[ aStream nextPutAll: 's'].

! !

!Measure methodsFor: 'as yet unclassified' stamp: 'GabrielBursztyn 6/3/2012 23:38'!
to: aDistance
	^IntervalOfMeasure  from: self   to: aDistance by:(Measure newWith: 1 unit: (self unit)).! !

!Measure methodsFor: 'as yet unclassified' stamp: 'GabrielBursztyn 6/3/2012 23:38'!
to: aDistance by: aDistanceStep
	^IntervalOfMeasure from: self to: aDistance by: aDistanceStep.! !

!Measure methodsFor: 'as yet unclassified' stamp: 'GabrielBursztynPabloSatelier 5/21/2012 20:50'!
unit
	^unit.! !

TestCase subclass: #MeasureTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'EjerciciosPoo-Measure'!

!MeasureTest methodsFor: 'errors' stamp: 'GabrielBursztyn 6/4/2012 16:40'!
canNotConvertMeasurementException
	^ CanNotConvertMeasurementException.
	"^ self error: 'Este metodo debe devolver el objeto que representa que no se pudo
		convertir una medida a la unidad pedida'"! !

!MeasureTest methodsFor: 'temperature units' stamp: 'GabrielBursztyn 6/4/2012 17:46'!
celsius
	
"	self error: 'Este metodo debe devolver un objeto que la unidad de temperatura Celsius"
	^MeasureUnitSimple celsius.! !

!MeasureTest methodsFor: 'distance units' stamp: 'GabrielBursztyn 6/4/2012 17:46'!
centimeter
	
"	self error: 'Este metodo debe devolver el objeto que la unidad de distancia centimetro'"
	^MeasureUnitSimple centimeter.! !

!MeasureTest methodsFor: 'time units' stamp: 'GabrielBursztyn 6/4/2012 17:46'!
day
"	self error: 'Este metodo debe devolver un objeto que represente la unidad dia'"
	^MeasureUnitSimple day.! !

!MeasureTest methodsFor: 'distance units' stamp: 'GabrielBursztyn 6/4/2012 17:46'!
decameter
	
"	self error: 'Este metodo debe devolver el objeto que la unidad de distancia decametro'"
	^MeasureUnitSimple decameter.! !

!MeasureTest methodsFor: 'distance units' stamp: 'GabrielBursztyn 6/4/2012 17:46'!
decimeter
	
	"self error: 'Este metodo debe devolver el objeto que la unidad de distancia decimetro'"
	^MeasureUnitSimple decimeter.! !

!MeasureTest methodsFor: 'distance measures' stamp: 'HernanWilkinson 4/25/2011 17:27'!
distanceExamples 

	^self objectsInCategoryOf: thisContext method selector.
	
! !

!MeasureTest methodsFor: 'distance units' stamp: 'HernanWilkinson 4/25/2011 17:27'!
distanceUnits 

	^self objectsInCategoryOf: thisContext method selector.
	
! !

!MeasureTest methodsFor: 'compound measures' stamp: 'GabrielBursztyn 6/4/2012 22:12'!
eightCubicMeters
"	^self error: 'este metodo debe devolver la medida 8 metros cubicos'"
	^Measure newWith: 8 unit: ((self meter)*(self meter) *(self meter)).! !

!MeasureTest methodsFor: 'temperature units' stamp: 'GabrielBursztyn 6/4/2012 17:46'!
fahrenheit
	
"	self error: 'Este metodo debe devolver un objeto que represente la unidad de temperatura Fahrenheit'"
	^MeasureUnitSimple fahrenheit.! !

!MeasureTest methodsFor: 'compound measures' stamp: 'GabrielBursztyn 6/4/2012 22:30'!
finalSpeedStartingAt: initialSpeed accelerating: anAcceleration during: aTimePeriod

"	^self error: 'Implementar la formula de velocidad final: vf = vi + a * t'"

	^ initialSpeed+ (anAcceleration * aTimePeriod).! !

!MeasureTest methodsFor: 'compound measures' stamp: 'GabrielBursztyn 6/4/2012 22:11'!
fourSquaredMeters
"	^self error: 'este metodo debe devolver la medida 4 metros cuadrados'"
	^Measure newWith: 4 unit: ((self meter) *(self meter)).! !

!MeasureTest methodsFor: 'distance units' stamp: 'GabrielBursztyn 6/4/2012 17:46'!
hectometer
	
	"self error: 'Este metodo debe devolver el objeto que la unidad de distancia hectometro'"
	^MeasureUnitSimple hectometer.! !

!MeasureTest methodsFor: 'time units' stamp: 'GabrielBursztyn 6/4/2012 17:46'!
hour
"	self error: 'Este metodo debe devolver un objeto que represente la unidad hora'"
	^MeasureUnitSimple hour.! !

!MeasureTest methodsFor: 'temperature units' stamp: 'GabrielBursztyn 6/4/2012 17:46'!
kelvin
	
"	self error: 'Este metodo debe devolver un objeto que represente la unidad de temperatura Kelvin'"
	^MeasureUnitSimple  kelvin.! !

!MeasureTest methodsFor: 'distance units' stamp: 'GabrielBursztyn 6/4/2012 17:46'!
kilometer
	
	"self error: 'Este metodo debe devolver el objeto que la unidad de distancia kilometro'"
	^MeasureUnitSimple kilometer.! !

!MeasureTest methodsFor: 'objects in category' stamp: 'HernanWilkinson 4/25/2011 17:30'!
measureExamples 

	^ OrderedCollection new
		addAll: self distanceExamples;
		addAll: self temperatureExamples;
		addAll: self timeExamples;
		yourself ! !

!MeasureTest methodsFor: 'distance units' stamp: 'GabrielBursztyn 6/4/2012 17:46'!
meter

"	self error: 'Este metodo debe devolver el objeto que la unidad de distancia metro'"
	^MeasureUnitSimple  meter.! !

!MeasureTest methodsFor: 'distance units' stamp: 'GabrielBursztyn 6/4/2012 17:46'!
millimeter
	
"	self error: 'Este metodo debe devolver el objeto que la unidad de distancia millimetro'"
	^MeasureUnitSimple milimeter.! !

!MeasureTest methodsFor: 'distance measures' stamp: 'GabrielBursztyn 6/3/2012 23:55'!
minusOneMeter 
	
	"self error: 'Este metodo debe devolver un objeto que represente un metro'"
	^Measure newWith: -1 unit: (self meter).! !

!MeasureTest methodsFor: 'time units' stamp: 'GabrielBursztyn 6/4/2012 17:46'!
minute
"	self error: 'Este metodo debe devolver un objeto que represente la unidad minuto'"
	^MeasureUnitSimple minute.! !

!MeasureTest methodsFor: 'objects in category' stamp: 'HernanWilkinson 4/25/2011 17:27'!
objectsInCategoryOf: aSelector

	| category messageNames |
	
	category := self class organization categoryOfElement: aSelector.
	messageNames := (self class organization listAtCategoryNamed:  category) reject: [ :aMessageName | aMessageName = aSelector ].
	
	 ^ messageNames collect: [ :aMessageName | self perform: aMessageName ]
	

	
! !

!MeasureTest methodsFor: 'temperature measures' stamp: 'Satelier 6/3/2012 12:02'!
oneCelsius
	
"	self error: 'Este metodo debe devolver un objeto que represente un grado centigrado'"
	^Measure newWith: 1 unit: (self celsius).! !

!MeasureTest methodsFor: 'distance measures' stamp: 'GabrielBursztyn 6/3/2012 23:39'!
oneCentimeter
	^Measure newWith: 1 unit: (self centimeter).! !

!MeasureTest methodsFor: 'time measures' stamp: 'GabrielBursztynPabloSatelier 5/30/2012 21:08'!
oneDay
	
	"self error: 'Este metodo debe devolver un objeto que represente un dia'"
	^Measure newWith: 1 unit: (self day).! !

!MeasureTest methodsFor: 'time measures' stamp: 'GabrielBursztynPabloSatelier 5/30/2012 21:07'!
oneHour
	
"	self error: 'Este metodo debe devolver un objeto que represente una hora'"
	^Measure newWith: 1 unit: (self hour).! !

!MeasureTest methodsFor: 'distance measures' stamp: 'GabrielBursztynPabloSatelier 5/30/2012 20:18'!
oneHundredCentimeters
	
"	self error: 'Este metodo debe devolver un objeto que represente cien centimetros"
	^Measure newWith: 100 unit: (self centimeter).! !

!MeasureTest methodsFor: 'compound measures' stamp: 'GabrielBursztyn 6/4/2012 22:24'!
oneHundredTwentyOneMetersPerSecond

"	^self error: 'este metodo debe devolver la medida 121 metro/segundo'"
	^Measure newWith: 121 unit: ((self meter)/(self second)).! !

!MeasureTest methodsFor: 'distance measures' stamp: 'GabrielBursztynPabloSatelier 5/30/2012 19:32'!
oneMeter
	
"	self error: 'Este metodo debe devolver un objeto que represente un metro'"
	^Measure newWith: 1 unit: (self meter).! !

!MeasureTest methodsFor: 'compound measures' stamp: 'GabrielBursztyn 6/5/2012 00:25'!
oneMeterPerSecond

	"^self error: 'este metodo debe devolver la medida 1 metro/segundo'"
	^Measure newWith: 1 unit: ((self meter)/(self second )).! !

!MeasureTest methodsFor: 'time measures' stamp: 'GabrielBursztynPabloSatelier 5/30/2012 20:20'!
oneMinute
"	self error: 'Este metodo debe devolver un objeto que represente un minuto'"
	^Measure newWith: 1 unit: (self minute).! !

!MeasureTest methodsFor: 'time measures' stamp: 'GabrielBursztynPabloSatelier 5/30/2012 19:34'!
oneSecond

"	self error: 'Este metodo debe devolver un objeto que represente un segundo'"
		^Measure newWith: 1 unit: (self second).! !

!MeasureTest methodsFor: 'compound measures' stamp: 'GabrielBursztyn 6/4/2012 22:10'!
oneSquaredMeter
"^self error: 'este metodo debe devolver la medida 1 metro cuadrado"
	^Measure newWith: 1 unit: ((self meter) * (self meter)).! !

!MeasureTest methodsFor: 'compound measures' stamp: 'GabrielBursztyn 6/4/2012 22:12'!
oneSquaredSecond

"	^self error: 'este metodo debe devolver la medida 1 segundo cuadrado'"
	^Measure newWith: 1 unit: ((self second)*(self second )).! !

!MeasureTest methodsFor: 'time units' stamp: 'GabrielBursztyn 6/4/2012 17:46'!
second
	
"	self error: 'Este metodo debe devolver un objeto que represente la unidad segundo"
	^MeasureUnitSimple  second.! !

!MeasureTest methodsFor: 'time measures' stamp: 'GabrielBursztynPabloSatelier 5/30/2012 20:20'!
sixtyMinutes
"	self error: 'Este metodo debe devolver un objeto que represente sesenta minutos'"
		^Measure newWith: 60 unit: (self minute).! !

!MeasureTest methodsFor: 'time measures' stamp: 'Satelier 6/3/2012 15:24'!
sixtyOneSeconds
	
	"self error: 'Este metodo debe devolver un objeto que represente sesenta y un segundos'"
	^Measure newWith: 61 unit: (self second).! !

!MeasureTest methodsFor: 'time measures' stamp: 'GabrielBursztynPabloSatelier 5/30/2012 19:40'!
sixtySeconds
	
"	self error: 'Este metodo debe devolver un objeto que represente sesenta segundos'"
	^Measure newWith: 60 unit: (self second).! !

!MeasureTest methodsFor: 'temperature measures' stamp: 'HernanWilkinson 4/25/2011 17:28'!
temperatureExamples

	^self objectsInCategoryOf: thisContext method selector.
	
! !

!MeasureTest methodsFor: 'temperature units' stamp: 'HernanWilkinson 4/25/2011 17:28'!
temperatureUnits

	^self objectsInCategoryOf: thisContext method selector.
	
! !

!MeasureTest methodsFor: '1 - Test equality' stamp: 'HernanWilkinson 4/25/2011 16:05'!
test01ObjectsRepresentingSameMeasureShouldBeEqual

	self assert: self oneMeter = self oneMeter.
	self assert: self oneSecond = self oneSecond.
	self assert: self oneCelsius = self oneCelsius.
	

! !

!MeasureTest methodsFor: '1 - Test equality' stamp: 'HernanWilkinson 4/25/2011 16:06'!
test02DifferentMeasuresShouldNotBeEqual

	self deny: self oneMeter = self twoMeters.
	self deny: self oneSecond = self sixtySeconds.
	self deny: self oneCelsius = self zeroCelsius.
! !

!MeasureTest methodsFor: '1 - Test equality' stamp: 'HernanWilkinson 4/25/2011 16:07'!
test03SameMeasureExpressWithDifferentUnitsShouldBeEqual

	self assert: self oneMeter = self oneHundredCentimeters.
	self assert: self twoMeters = self twoHundredCentimeters.
	self assert: self oneMinute = self sixtySeconds.
	self assert: self zeroCelsius = self thirtyTwoFahrenheits.
! !

!MeasureTest methodsFor: '1 - Test equality' stamp: 'GabrielBursztynPabloSatelier 5/30/2012 20:28'!
test03aMeasuresOfDifferentDomainShouldNotBeEqual

	self deny: self oneMeter = self oneSecond.
	self deny: self oneMeter = self oneCelsius.
	self deny: self oneCelsius = self oneSecond
! !

!MeasureTest methodsFor: '1 - Test equality' stamp: 'HernanWilkinson 4/25/2011 16:09'!
test04EqualsShouldBeCommutative

	self assert: (self oneMeter = self oneHundredCentimeters and: [ self oneHundredCentimeters = self oneMeter ]).
	self assert: (self twoMeters = self twoHundredCentimeters and:  [ self twoHundredCentimeters = self twoMeters ]).
	self assert: (self oneMinute = self sixtySeconds and: [self sixtySeconds = self oneMinute]).
	self assert: (self zeroCelsius = self thirtyTwoFahrenheits and: [ self thirtyTwoFahrenheits = self zeroCelsius]).
! !

!MeasureTest methodsFor: '2 - Converting/accessing/printing' stamp: 'HernanWilkinson 4/25/2011 16:11'!
test05UnitStringRepresentationShouldBeHumanReadable

	self assert: self meter printString = 'meter'.
	self assert: self centimeter printString = 'centimeter'.
	self assert: self decimeter printString = 'decimeter'.
	self assert: self millimeter printString = 'milimeter'.
	self assert: self decameter printString = 'decameter'.
	self assert: self hectometer printString = 'hectometer'.
	self assert: self kilometer printString = 'kilometer'.	
	
	self assert: self celsius printString = 'celsius'.	
	self assert: self fahrenheit printString = 'fahrenheit'.	

	self assert: self day printString = 'day'.	
	self assert: self hour printString = 'hour'.	
	self assert: self minute printString = 'minute'.	
	self assert: self second printString = 'second'.	

! !

!MeasureTest methodsFor: '2 - Converting/accessing/printing' stamp: 'GabrielBursztynPabloSatelier 5/30/2012 20:36'!
test06MeasureStringRepresentationShouldBeHumanReadable

	self assert: self oneMeter printString = '1 meter'.
	self assert: self twoMeters printString = '2 meters'.
	self assert: self oneHundredCentimeters printString = '100 centimeters'.
	
	self assert: self oneMinute printString = '1 minute'.
	self assert: self sixtySeconds printString = '60 seconds'.
	
	self assert: self zeroCelsius printString = '0 celsius'.
	self assert: self thirtyTwoFahrenheits printString = '32 fahrenheits'.
	
	
! !

!MeasureTest methodsFor: '2 - Converting/accessing/printing' stamp: 'HernanWilkinson 4/25/2011 16:14'!
test07aMeasureAmountShouldBeTheExpectedAmount

	self assert: self oneMeter amount = 1.
	self assert: self twoMeters amount = 2.
	self assert: self oneHundredCentimeters amount = 100.
	self assert: self twoHundredCentimeters amount = 200.

	self assert: self oneMinute amount = 1.
	self assert: self sixtySeconds amount = 60.
	
	self assert: self zeroCelsius amount = 0.
	self assert: self thirtyTwoFahrenheits amount = 32.
! !

!MeasureTest methodsFor: '2 - Converting/accessing/printing' stamp: 'GabrielBursztynPabloSatelier 5/30/2012 20:41'!
test07bMeasureUnitShouldBeTheExpectedUnit

	self assert: self oneMeter unit = self meter.
	self assert: self twoMeters unit = self meter.
	self assert: self oneHundredCentimeters unit = self centimeter.
	self assert: self twoHundredCentimeters unit = self centimeter.
	
	self assert: self oneMinute unit = self minute.
	self assert: self sixtySeconds unit = self second.
	
	self assert: self zeroCelsius unit = self celsius.
	self assert: self thirtyTwoFahrenheits unit = self fahrenheit
! !

!MeasureTest methodsFor: '2 - Converting/accessing/printing' stamp: 'GabrielBursztynPabloSatelier 5/30/2012 21:06'!
test07cDifferentMeasureUnitsShouldBeDifferent

	| unitsGroupedByItself |


	unitsGroupedByItself := self units groupedBy: [ :aUnit | aUnit ].
	self assert: (unitsGroupedByItself allSatisfy: [:aCollectionOfUnit | aCollectionOfUnit size = 1] )
! !

!MeasureTest methodsFor: '2 - Converting/accessing/printing' stamp: 'HernanWilkinson 4/25/2011 16:03'!
test07dDistancesCanBeConvertedToDifferentUnits

	"A partir de los test de igualdad, se deben haber dado cuenta que debemos poder
	convertir distancias a distintas unidades... y que ademas dos distancias de distintas unidades
	pueden ser iguales... Por lo tanto por qu no hacer esta caracteristica de las distancias explicita?
	Veran que luego se torna muy util
	
	Respecto de como esta escrito el test, para no tener que escribir los assert para oneMeter y oneHundredCentimeters 
	creo un array y lo recorro... Se podria escribir menos aun en este test?
	
	Y por qu se asserta sobre el amount y luego la unidad y no directametne sobre la distancia completa. ej:
	self assert: (aDistance converTo: self meter) = self oneMeter
	"
	
	(Array with: self oneMeter with: self oneHundredCentimeters) do: [ :aDistance |
		self assert: (aDistance convertTo: self meter) amount = 1.
		self assert: (aDistance convertTo: self meter) unit = self meter.
		
		self assert: (aDistance convertTo: self decimeter) amount = 10.
		self assert: (aDistance convertTo: self decimeter) unit = self decimeter.
		
		self assert: (aDistance convertTo: self centimeter) amount = 100.
		self assert: (aDistance convertTo: self centimeter) unit = self centimeter.
		
		self assert: (aDistance convertTo: self millimeter) amount = 1000.
		self assert: (aDistance convertTo: self millimeter) unit = self millimeter.
	
		self assert: (aDistance convertTo: self decameter) amount = (1/10).
		self assert: (aDistance convertTo: self decameter) unit = self decameter.
		
		self assert: (aDistance convertTo: self hectometer) amount = (1/100).
		self assert: (aDistance convertTo: self hectometer) unit = self hectometer.
	
		self assert: (aDistance convertTo: self kilometer) amount = (1/1000).
		self assert: (aDistance convertTo: self kilometer) unit = self kilometer ]! !

!MeasureTest methodsFor: '2 - Converting/accessing/printing' stamp: 'GabrielBursztynPabloSatelier 5/30/2012 21:07'!
test07eTimeMeasuresCanBeConvertedToDifferentUnits

	self assert: (self oneMinute convertTo: self second) = self sixtySeconds.
	self assert: (self sixtySeconds convertTo: self minute) = self oneMinute.

	self assert: (self oneHour convertTo: self minute) = self sixtyMinutes.
	self assert: (self sixtyMinutes convertTo: self hour) = self oneHour.

	self assert: (self oneDay convertTo: self hour) = self twentyFourHours.
	self assert: (self twentyFourHours convertTo: self day) = self oneDay.

! !

!MeasureTest methodsFor: '2 - Converting/accessing/printing' stamp: 'HernanWilkinson 4/25/2011 16:17'!
test07fTemperatureMeasuresCanBeConvertedToDifferentUnits

	self assert: (self zeroCelsius convertTo: self fahrenheit) = self thirtyTwoFahrenheits.
	self assert: (self thirtyTwoFahrenheits convertTo: self celsius) = self zeroCelsius.

! !

!MeasureTest methodsFor: '2 - Converting/accessing/printing' stamp: 'HernanWilkinson 4/25/2011 16:19'!
test07gMeasuresCanNotBeConvertedToUnitsOfDifferentDomain

	self should: [ self oneMeter convertTo: self second ] raise: self canNotConvertMeasurementException.
	self should: [ self oneSecond convertTo: self celsius ] raise: self canNotConvertMeasurementException.
	self should: [ self oneCelsius convertTo: self centimeter ] raise: self canNotConvertMeasurementException.


! !

!MeasureTest methodsFor: '3 - Test equality - implementation details' stamp: 'HernanWilkinson 4/25/2011 16:20'!
test08aComparingMeasuresWithOtherObjectsShouldReturnFalse

	"El igual no debe generar ningun tipo de error por mas que se comparen objetos
	de distintos tipos
	Fijense como se crea una instancia de Object sin ningun tipo de problema... qu representa?"

	self deny: self oneMeter = Object new.
	self deny: Object new = self oneMeter! !

!MeasureTest methodsFor: '3 - Test equality - implementation details' stamp: 'HernanWilkinson 4/25/2011 16:21'!
test08bMeasuresThatAreEqualShouldReturnTheSameHash

	"Debido a como funcionan los diccionarios, cuando dos objetos son iguales deben
	tener es mismo hash. La inversa no es verdad"
	
	self assert: self oneMeter hash=self oneMeter hash.
	self assert: self oneMeter hash=self oneHundredCentimeters hash.
	self assert: self oneMinute hash = self sixtySeconds hash.
	self assert: self zeroCelsius hash = self thirtyTwoFahrenheits hash.
	
	
! !

!MeasureTest methodsFor: '3 - Test equality - implementation details' stamp: 'HernanWilkinson 4/25/2011 16:21'!
test08cCopiesOfTheSameMeasureShouldBeEqual

	"Dos objetos que ocupan distintas posiciones de memoria pero representan
	la misma entidad de la realidad, deben devolver true cuando se los compara por igual, puesto
	que representan la misma entidad de la realidad.
	Por lo tanto, el mensaje #= significa 'representan el mismo ente de la realidad?'
	mientras que el mensaje #== significa ocupan la misma posicion de memoria?"

	| originalOneMeter copiedOneMeter |

	"Al objeto oneMeter lo copio para asegurarme de tener uno oneMeter en otra posicion de memoria"

	originalOneMeter := self oneMeter.
	copiedOneMeter := originalOneMeter copy.

	"Me aseguro que ocupen distinta posicion de memoria"
	self deny: originalOneMeter == copiedOneMeter.

	"Ahora me aseguro que sean iguales"
	self assert: originalOneMeter = copiedOneMeter! !

!MeasureTest methodsFor: '4 - Test arithmetic operations' stamp: 'HernanWilkinson 4/25/2011 16:31'!
test09AddingMeasuresOfSameUnitShouldReturnAMeasureRepresentingTheAddingMeasures

	self assert: (self oneMeter + self oneMeter) = self twoMeters.
	self assert: (self oneSecond + self oneSecond) = self twoSeconds.
	self assert: (self oneCelsius + self oneCelsius) = self twoCelsius.
	

! !

!MeasureTest methodsFor: '4 - Test arithmetic operations' stamp: 'HernanWilkinson 4/25/2011 16:32'!
test10AddingMeasuresOfDifferentUnitShouldReturnAMeasureRepresentingTheAddingMeasures

	self assert: (self oneMeter + self oneHundredCentimeters) = self twoMeters.
	self assert: (self oneMeter + self oneHundredCentimeters) = self twoHundredCentimeters.
	self assert: (self oneSecond + self oneMinute) = self sixtyOneSeconds.

! !

!MeasureTest methodsFor: '4 - Test arithmetic operations' stamp: 'HernanWilkinson 4/25/2011 16:48'!
test10aCanNotAddMeasuresOfDifferentDomain

	self should: [ self oneMeter + self oneSecond ] raise: self canNotConvertMeasurementException 

! !

!MeasureTest methodsFor: '4 - Test arithmetic operations' stamp: 'HernanWilkinson 4/25/2011 16:32'!
test11AddingMeasuresIsCommutative

	self assert: (self oneMeter + self twoMeters)=(self twoMeters + self oneMeter).
	self assert: (self oneSecond + self twoSeconds)=(self twoSeconds + self oneSecond).
	self assert: (self oneCelsius + self twoCelsius)=(self twoCelsius + self oneCelsius)
	


! !

!MeasureTest methodsFor: '4 - Test arithmetic operations' stamp: 'HernanWilkinson 4/25/2011 16:33'!
test12AddingMeasuresIsAssociative

	self assert: 
		((self oneMeter + self oneMeter) + self twoMeters) = 
		(self oneMeter + (self oneMeter + self twoMeters)).

	self assert: 
		((self oneSecond + self oneSecond) + self twoSeconds) = 
		(self oneSecond + (self oneSecond + self twoSeconds)).

	self assert: 
		((self oneCelsius + self oneCelsius) + self twoCelsius) = 
		(self oneCelsius + (self oneCelsius + self twoCelsius)).

		

! !

!MeasureTest methodsFor: '4 - Test arithmetic operations' stamp: 'HernanWilkinson 4/25/2011 16:35'!
test12aAddingMeasuresKeepsMeasureImmutability

	| oneMeter oneSecond oneCelsius |
	
	oneMeter := self oneMeter.
	oneMeter + oneMeter.
	
	self assert: oneMeter = self oneMeter.
	
	oneSecond := self oneSecond.
	oneSecond + oneSecond.
	
	self assert: oneSecond = self oneSecond.
	
	oneCelsius := self oneCelsius.
	oneCelsius + oneCelsius.
	
	self assert: oneCelsius = self oneCelsius 



! !

!MeasureTest methodsFor: '4 - Test arithmetic operations' stamp: 'HernanWilkinson 4/25/2011 16:36'!
test13aNegatingAMeasureNegatesItsAmount

	(Array with: self oneMeter with: self twoSeconds with: self thirtyTwoFahrenheits) do: [:aMeasure |
		self assert: aMeasure negated amount=aMeasure amount negated ]
! !

!MeasureTest methodsFor: '4 - Test arithmetic operations' stamp: 'HernanWilkinson 4/25/2011 16:36'!
test13bNegatingAMeasureIsReflective

	(Array with: self oneMeter with: self twoSeconds with: self thirtyTwoFahrenheits) do: [:aMeasure |
		self assert: aMeasure negated negated=aMeasure ].
! !

!MeasureTest methodsFor: '4 - Test arithmetic operations' stamp: 'HernanWilkinson 4/25/2011 16:37'!
test14SubtractingMeasuresOfSameUnitShouldReturnAMeasureRepresentingTheSubtractedMeasures

	self assert: (self twoMeters - self oneMeter) = self oneMeter.
	self assert: (self oneMeter - self oneMeter) = self zeroMeters.
	self assert: (self oneMeter - self twoMeters) = self oneMeter negated.
	
	self assert: (self twoSeconds - self oneSecond) = self oneSecond.
	self assert: (self oneSecond - self oneSecond) = self zeroSeconds.
	self assert: (self oneSecond - self twoSeconds) = self oneSecond negated.
	
	self assert: (self twoCelsius - self oneCelsius) = self oneCelsius.
	self assert: (self oneCelsius - self oneCelsius) = self zeroCelsius.
	self assert: (self oneCelsius - self twoCelsius) = self oneCelsius negated.
! !

!MeasureTest methodsFor: '4 - Test arithmetic operations' stamp: 'HernanWilkinson 4/25/2011 16:38'!
test15SubtractingMeasuresOfDifferentUnitShouldReturnAMeasureRepresentingTheSubtractedMeasures

	self assert: (self twoMeters - self oneHundredCentimeters) = self oneMeter.
	self assert: (self oneMeter - self oneHundredCentimeters) = self zeroMeters.
	self assert: (self oneHundredCentimeters - self twoMeters) = self oneMeter negated.
	
	self assert: (self sixtyOneSeconds - self oneMinute) = self oneSecond.
	

	! !

!MeasureTest methodsFor: '4 - Test arithmetic operations' stamp: 'HernanWilkinson 4/25/2011 16:48'!
test15aCanNotSubtractMeasuresOfDifferentDomain

	self should: [ self oneMeter - self oneSecond ] raise: self canNotConvertMeasurementException 

! !

!MeasureTest methodsFor: '4 - Test arithmetic operations' stamp: 'HernanWilkinson 4/25/2011 16:38'!
test16SubtractingMeasuresIsAssociative

	self assert: 
		((self twoMeters - self oneMeter) - self oneMeter) = 
		(self twoMeters - (self oneMeter + self oneMeter)).

	self assert: 
		((self twoSeconds - self oneSecond) - self oneSecond) = 
		(self twoSeconds - (self oneSecond + self oneSecond)).	

	

	! !

!MeasureTest methodsFor: '4 - Test arithmetic operations' stamp: 'HernanWilkinson 4/25/2011 16:39'!
test16aSubtractingMeasuresKeepsMeasuresImmutability

	| oneMeter oneSecond oneCelsius |
	
	oneMeter := self oneMeter.
	oneMeter - oneMeter.
	
	self assert: oneMeter = self oneMeter.
	
	oneSecond := self oneSecond.
	oneSecond - oneSecond.
	
	self assert: oneSecond = self oneSecond.
	
	oneCelsius := self oneCelsius.
	oneCelsius - oneCelsius.
	
	self assert: oneCelsius = self oneCelsius 


! !

!MeasureTest methodsFor: '4 - Test arithmetic operations' stamp: 'HernanWilkinson 4/25/2011 16:40'!
test17aMeasuresCanBeMultiplyByAnInteger

	self assert: self oneMeter * 1 = self oneMeter.
	self assert: self oneMeter * 2 = self twoMeters.
	self assert: self oneMeter * 0 = self zeroMeters.

	self assert: self oneSecond * 1 = self oneSecond.
	self assert: self oneSecond * 2 = self twoSeconds.
	self assert: self oneSecond * 0 = self zeroSeconds.

	self assert: self oneCelsius * 1 = self oneCelsius.
	self assert: self oneCelsius * 2 = self twoCelsius.
	self assert: self oneCelsius * 0 = self zeroCelsius.
! !

!MeasureTest methodsFor: '4 - Test arithmetic operations' stamp: 'HernanWilkinson 4/25/2011 16:40'!
test17bMeasuresCanBeMultiplyByAFraction

	self assert: (self oneMeter * (2/3)) amount = (2/3).
	self assert: (self twoMeters * (2/3)) amount = (2 * (2/3)).

	self assert: (self oneSecond * (2/3)) amount = (2/3).
	self assert: (self twoSeconds * (2/3)) amount = (2 * (2/3)).

	self assert: (self oneCelsius * (2/3)) amount = (2/3).
	self assert: (self twoCelsius * (2/3)) amount = (2 * (2/3)).
! !

!MeasureTest methodsFor: '4 - Test arithmetic operations' stamp: 'HernanWilkinson 4/25/2011 16:41'!
test17cMeasuresCanBeMultiplyByAFloat

	self assert: (self oneMeter * 2.5) amount = 2.5.
	self assert: (self twoMeters * 2.5) amount = (2 * 2.5).

	self assert: (self oneSecond * 2.5) amount = 2.5.
	self assert: (self twoSeconds * 2.5) amount = (2 * 2.5).

	self assert: (self oneCelsius * 2.5) amount = 2.5.
	self assert: (self twoCelsius * 2.5) amount = (2 * 2.5).
! !

!MeasureTest methodsFor: '4 - Test arithmetic operations' stamp: 'HernanWilkinson 4/25/2011 16:45'!
test17dMeasuresCanBeMultiplyByAMeasureOfSameDomain

	self assert: (self oneMeter * self oneMeter) = self oneSquaredMeter.
	self assert: (self twoMeters * self twoMeters) = self fourSquaredMeters.
	self assert: (self twoMeters * self twoMeters * self twoMeters) = self eightCubicMeters.

	self assert: (self oneSecond * self oneSecond) = self oneSquaredSecond.
! !

!MeasureTest methodsFor: '4 - Test arithmetic operations' stamp: 'GabrielBursztyn 6/5/2012 11:06'!
test17eMeasuresCanBeMultiplyByAMeasureOfDifferentDomain

	self assert: (self twoMeters / self oneSecond) = self twoMetersTimesSecond.


! !

!MeasureTest methodsFor: '4 - Test arithmetic operations' stamp: 'HernanWilkinson 4/25/2011 16:42'!
test18MultiplicationKeepsMeasureImmutability

	| oneMeter oneSecond oneCelsius |
	
	oneMeter := self oneMeter.
	oneMeter * 2.
	
	self assert: oneMeter = self oneMeter.
	
	oneSecond := self oneSecond.
	oneSecond * 2.
	
	self assert: oneSecond = self oneSecond.
	
	oneCelsius := self oneCelsius.
	oneCelsius * 2.
	
	self assert: oneCelsius = self oneCelsius 




! !

!MeasureTest methodsFor: '4 - Test arithmetic operations' stamp: 'HernanWilkinson 4/25/2011 16:49'!
test19aMeasuresCanBeDividedByAnInteger

	self assert: (self oneMeter / 1) = self oneMeter.
	self assert: (self twoMeters / 2) = self oneMeter.

	self assert: (self oneSecond / 1) = self oneSecond.
	self assert: (self twoSeconds / 2) = self oneSecond.

	self assert: (self oneCelsius / 1) = self oneCelsius.
	self assert: (self twoCelsius / 2) = self oneCelsius.

! !

!MeasureTest methodsFor: '4 - Test arithmetic operations' stamp: 'HernanWilkinson 4/25/2011 16:50'!
test19bMeasuresCanBeDividedByAFraction

	self assert: (self twoMeters / (1/3)) amount = 6.
	self assert: (self twoSeconds / (1/3)) amount = 6.
	self assert: (self twoCelsius / (1/3)) amount = 6.




! !

!MeasureTest methodsFor: '4 - Test arithmetic operations' stamp: 'HernanWilkinson 4/25/2011 16:50'!
test19cMeasuresCanBeDividedByAFloat

	self assert: (self twoMeters / 2.5) amount = (2/2.5).
	self assert: (self twoSeconds / 2.5) amount = (2/2.5).
	self assert: (self twoCelsius / 2.5) amount = (2/2.5).




! !

!MeasureTest methodsFor: '4 - Test arithmetic operations' stamp: 'HernanWilkinson 4/25/2011 16:52'!
test19dMeasuresCanBeDividedByAMeasureOfSameDomain

	self assert: (self oneMeter / self oneMeter) = 1.
	self assert: (self twoMeters / self oneMeter) = 2.
		
	self assert: (self oneSecond / self oneSecond) = 1.
! !

!MeasureTest methodsFor: '4 - Test arithmetic operations' stamp: 'GabrielBursztyn 6/5/2012 11:24'!
test19eMeasuresCanBeDividedByAMeasureOfDifferentDomain

	self assert: (self twoMeters / self oneSecond) = self twoMetersBySecond.
! !

!MeasureTest methodsFor: '4 - Test arithmetic operations' stamp: 'HernanWilkinson 4/25/2011 16:54'!
test20DivisionKeepsMeasureImmutability

	| oneMeter oneSecond oneCelsius |
	
	oneMeter := self oneMeter.
	oneMeter / 2.
	
	self assert: oneMeter = self oneMeter.
	
	oneSecond := self oneSecond.
	oneSecond / 2.
	
	self assert: oneSecond = self oneSecond.
	
	oneCelsius := self oneCelsius.
	oneCelsius / 2.
	
	self assert: oneCelsius = self oneCelsius 


! !

!MeasureTest methodsFor: '4 - Test arithmetic operations' stamp: 'GabrielBursztyn 6/5/2012 12:30'!
test20aFinalSpeedCanBeRepresentedWithMeasures

	self assert: 
		(self finalSpeedStartingAt: self oneMeterPerSecond accelerating: self twoMetersPerSquaredSecond during: self sixtySeconds) = 
		(self oneMeterPerSecond + (self twoMetersPerSquaredSecond * self sixtySeconds)).
		
	self assert: (self finalSpeedStartingAt: self oneMeterPerSecond accelerating: self twoMetersPerSquaredSecond during: self sixtySeconds) = self oneHundredTwentyOneMetersPerSecond 
	
! !

!MeasureTest methodsFor: '4 - Test arithmetic operations' stamp: 'HernanWilkinson 4/25/2011 17:00'!
test20bMultiplyingANumberByAUnitReturnsAMeasure

	self assert: (1*self meter) = self oneMeter.
	self assert: (2*self second) = self twoSeconds.
! !

!MeasureTest methodsFor: '5 - Test magnitude protocol' stamp: 'HernanWilkinson 4/25/2011 17:02'!
test21MeasuresProvideATotalOrder

	self assert: (self measureExamples allSatisfy: [ :aMeasure | aMeasure < (aMeasure + (1* aMeasure unit))])

! !

!MeasureTest methodsFor: '5 - Test magnitude protocol' stamp: 'HernanWilkinson 4/25/2011 17:03'!
test22MeasuresCanBeComparedWithGreaterThan

	self assert: (self measureExamples allSatisfy: [ :aMeasure | (aMeasure + (1 * aMeasure unit)) > aMeasure ])
! !

!MeasureTest methodsFor: '5 - Test magnitude protocol' stamp: 'HernanWilkinson 4/25/2011 17:04'!
test23MeasuresCanBeComparedWithLessThanOrEqual

	self assert: (self measureExamples allSatisfy: [ :aMeasure | aMeasure <= aMeasure and: [aMeasure <= (aMeasure + (1 * aMeasure unit))]])

	
! !

!MeasureTest methodsFor: '5 - Test magnitude protocol' stamp: 'HernanWilkinson 4/25/2011 17:05'!
test24MeasuresCanBeComparedWithGreaterThanOrEqual

	self assert: (self measureExamples allSatisfy: [ :aMeasure | aMeasure >= aMeasure and: [(aMeasure + (1 * aMeasure unit)) >= aMeasure]])! !

!MeasureTest methodsFor: '5 - Test magnitude protocol' stamp: 'HernanWilkinson 4/25/2011 17:05'!
test25MaxReturnsTheMaximumBetweenTwoMeasures

	self assert: (self twoMeters max: self oneMeter) = self twoMeters.
	self assert: (self oneMeter max: self twoMeters) = self twoMeters.

	self assert: (self twoMeters max: self oneHundredCentimeters) = self twoMeters.
	self assert: (self oneHundredCentimeters max: self twoMeters) = self twoMeters.

	
! !

!MeasureTest methodsFor: '5 - Test magnitude protocol' stamp: 'HernanWilkinson 4/25/2011 17:05'!
test26MinReturnsTheMinimumBetweenTwoMeasures

	self assert: (self twoMeters min: self oneMeter) = self oneMeter.
	self assert: (self oneMeter min: self twoMeters) = self oneMeter.

	self assert: (self twoMeters min: self oneHundredCentimeters) = self oneHundredCentimeters.
	self assert: (self oneHundredCentimeters min: self twoMeters) = self oneHundredCentimeters.

	
! !

!MeasureTest methodsFor: '5 - Test magnitude protocol' stamp: 'HernanWilkinson 4/25/2011 17:05'!
test27BetweenAndReturnsTrueIfAMeasureIsBetweenOtherTwoMeasures

	self assert: (self oneMeter between: self zeroMeters and: self twoMeters).
	self assert: (self oneHundredCentimeters between: self zeroMeters and: self twoMeters).
	
	self deny: (self twoMeters between: self zeroMeters and: self oneMeter).
	self deny: (self twoHundredCentimeters between: self zeroMeters and: self oneMeter).

! !

!MeasureTest methodsFor: '6 - Test interval protocol' stamp: 'GabrielBursztyn 6/3/2012 23:27'!
test28IntervalOfMeasuresCanBeCreatedBecauseTheyDefineATotalOrder

	self assert: (self oneMeter to: self twoMeters) first=self oneMeter.
	self assert: (self oneMeter to: self twoMeters) last=self twoMeters.
	self assert: (self oneMeter to: self twoMeters) increment =self oneMeter.	

	self assert: (self oneHundredCentimeters to: self twoMeters) first=self oneMeter.
	self assert: (self oneHundredCentimeters to: self twoMeters) last=self twoMeters.
	self assert: (self oneHundredCentimeters to: self twoMeters) increment=self oneCentimeter.	
	

! !

!MeasureTest methodsFor: '6 - Test interval protocol' stamp: 'HernanWilkinson 4/25/2011 17:16'!
test29MeasureIntervalStepCanBeAnyMeasure

	self assert: (self zeroMeters to: (self twoMeters * 2) by: self twoMeters) first=self zeroMeters.
	self assert: (self zeroMeters to: (self twoMeters * 2) by: self twoMeters) last=(self twoMeters * 2).
	self assert: (self zeroMeters to: (self twoMeters * 2) by: self twoMeters) increment=self twoMeters.

	self assert: ((self twoMeters * 2) to: self zeroMeters by: self twoMeters negated) first=(self twoMeters * 2).
	self assert: ((self twoMeters * 2) to: self zeroMeters by: self twoMeters negated) last=self zeroMeters.
	self assert: ((self twoMeters * 2) to: self zeroMeters by: self twoMeters negated) increment=self twoMeters negated

	! !

!MeasureTest methodsFor: '6 - Test interval protocol' stamp: 'HernanWilkinson 4/25/2011 17:17'!
test30MeasureIntervalSizeReturnsTheNumberOfMeasuresOfTheInterval

	self assert: (self zeroMeters to: (self twoMeters * 2) ) size =5.
	self assert: ((self twoMeters * 2) to: self zeroMeters by: self oneMeter negated) size =5.
! !

!MeasureTest methodsFor: '6 - Test interval protocol' stamp: 'HernanWilkinson 4/25/2011 17:17'!
test31MeasureIntervalCanBeEnumeratedUsingDo

	| value |
	
	value := 1.
	(self oneMeter to: (self oneMeter * 10)) do: [ :aMeasure |
		self assert: aMeasure amount = value.
		value := value + 1 ].
	
	self assert: value = 11
! !

!MeasureTest methodsFor: '6 - Test interval protocol' stamp: 'HernanWilkinson 4/25/2011 17:18'!
test32MeasureIntervalCanBeEnumeratedWithSpecificStep

	| value initialDistance byDistance finalDistance |
	
	initialDistance := self oneMeter.
	byDistance := self twoMeters.
	finalDistance := initialDistance * 9.
	value := initialDistance amount.
		
	(initialDistance to: finalDistance by:  byDistance) do: [ :aMeasure |
		self assert: aMeasure amount = value.
		value := value + byDistance amount ].
	
	self assert:  value = (finalDistance amount + byDistance amount)
! !

!MeasureTest methodsFor: '7 - Polymorphic zero' stamp: 'HernanWilkinson 4/25/2011 17:20'!
test33NothingOnAnyDomainAreEquals

	self assert: self zeroMeters = self zeroSeconds.
	self assert: self zeroSeconds = self zeroKelvin.
	self assert: self zeroKelvin = self zeroMeters! !

!MeasureTest methodsFor: '7 - Polymorphic zero' stamp: 'HernanWilkinson 4/25/2011 17:42'!
test34ZeroCelsiusIsNotNothingOnTemperature

	self deny: self zeroCelsius = self zeroKelvin.
	self deny: self zeroSeconds = self zeroCelsius.
! !

!MeasureTest methodsFor: 'temperature measures' stamp: 'Satelier 6/3/2012 16:50'!
thirtyTwoFahrenheits
	
"	self error: 'Este metodo debe devolver un objeto que represente 32 fahrenhetis, o sea"
"	0 grados centigrados'"
	^Measure newWith: 32 unit: (self fahrenheit ).! !

!MeasureTest methodsFor: 'time measures' stamp: 'HernanWilkinson 4/25/2011 17:29'!
timeExamples

	^self objectsInCategoryOf: thisContext method selector.
	
! !

!MeasureTest methodsFor: 'time units' stamp: 'HernanWilkinson 4/29/2011 17:10'!
timeUnits

	^self objectsInCategoryOf: thisContext method selector.
	
 ! !

!MeasureTest methodsFor: 'time measures' stamp: 'GabrielBursztynPabloSatelier 5/30/2012 21:08'!
twentyFourHours
	
"	self error: 'Este metodo debe devolver un objeto que represente veinticuatros horas'"
	^Measure newWith: 24 unit: (self hour ).! !

!MeasureTest methodsFor: 'temperature measures' stamp: 'Satelier 6/3/2012 15:23'!
twoCelsius
	
	"self error: 'Este metodo debe devolver un objeto que represente dos grados centigrados'"
	^Measure newWith: 2 unit: (self celsius).! !

!MeasureTest methodsFor: 'distance measures' stamp: 'GabrielBursztynPabloSatelier 5/30/2012 20:19'!
twoHundredCentimeters
"	self error: 'Este metodo debe devolver un objeto que represente doscientos centimetros"
	^Measure newWith: 200 unit: (self centimeter).! !

!MeasureTest methodsFor: 'distance measures' stamp: 'GabrielBursztynPabloSatelier 5/30/2012 19:39'!
twoMeters
	
"	self error: 'Este metodo debe devolver un objeto que represente dos metros'"
		^Measure newWith: 2 unit: (self meter).! !

!MeasureTest methodsFor: 'compound measures' stamp: 'GabrielBursztyn 6/4/2012 22:17'!
twoMetersBySecond

"	^self error: 'este metodo debe devolver la medida 2 metros/segundo'"
	^Measure newWith: 2 unit: ((self meter)/(self second )).! !

!MeasureTest methodsFor: 'compound measures' stamp: 'GabrielBursztyn 6/5/2012 00:26'!
twoMetersPerSquaredSecond

	"^self error: 'este metodo debe devolver la medida 2 metros/segundoAlCuadrado'"
	^Measure newWith: 2 unit: ((self meter)/((self second)*(self second))).! !

!MeasureTest methodsFor: 'compound measures' stamp: 'GabrielBursztyn 6/4/2012 22:13'!
twoMetersTimesSecond
	"^self error: 'este metodo debe devolver la medida 2 metros*segundo'"
	^Measure newWith: 2 unit: ((self meter)*(self second )).! !

!MeasureTest methodsFor: 'time measures' stamp: 'Satelier 6/3/2012 15:23'!
twoSeconds
	
"	self error: 'Este metodo debe devolver un objeto que represente dos segundos'"
	^Measure newWith: 2 unit: (self second).! !

!MeasureTest methodsFor: 'objects in category' stamp: 'HernanWilkinson 4/25/2011 17:34'!
units 

	^ OrderedCollection new
		addAll: self distanceUnits;
		addAll: self temperatureUnits;
		addAll: self timeUnits;
		yourself ! !

!MeasureTest methodsFor: 'temperature measures' stamp: 'GabrielBursztynPabloSatelier 5/30/2012 19:39'!
zeroCelsius
	
"	self error: 'Este metodo debe devolver un objeto que represente cero grados centrigrados'"
	^Measure newWith: 0 unit: (self celsius ).! !

!MeasureTest methodsFor: 'temperature measures' stamp: 'GabrielBursztyn 6/3/2012 23:49'!
zeroKelvin
	
	"self error: 'Este metodo debe devolver un objeto que represente cero kelvin"
	^Measure newWith: 0 unit: self kelvin. ! !

!MeasureTest methodsFor: 'distance measures' stamp: 'Satelier 6/3/2012 15:46'!
zeroMeters

	"self error: 'Este metodo debe devolver un objeto que represente cero metros'"
	^Measure newWith: 0 unit: self meter. ! !

!MeasureTest methodsFor: 'time measures' stamp: 'Satelier 6/3/2012 15:47'!
zeroSeconds
	
	"self error: 'Este metodo debe devolver un objeto que represente cero segundos'"
	^Measure newWith: 0 unit: self second. ! !

Error subclass: #CanNotConvertMeasurementException
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'EjerciciosPoo-Measure'!

Object subclass: #MeasureUnit
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'EjerciciosPoo-Measure'!

!MeasureUnit methodsFor: 'as yet unclassified' stamp: 'GabrielBursztyn 6/5/2012 12:03'!
* aMeasureUnit
	^MeasureUnitCompound newWith: self per: aMeasureUnit.
	
	
	

 ! !

!MeasureUnit methodsFor: 'as yet unclassified' stamp: 'GabrielBursztyn 6/5/2012 12:03'!
/ aMeasureUnit
	^MeasureUnitCompound newWith: self by: aMeasureUnit.


	

 ! !

!MeasureUnit methodsFor: 'as yet unclassified' stamp: 'GabrielBursztyn 6/4/2012 20:50'!
= aMeasureUnit
		self subclassResponsibility.
	! !

!MeasureUnit methodsFor: 'as yet unclassified' stamp: 'GabrielBursztyn 6/4/2012 17:46'!
adaptToNumber: aNumber andSend: selector
	^(Measure newWith: 1 unit: self)   perform: selector with: aNumber! !

!MeasureUnit methodsFor: 'as yet unclassified' stamp: 'GabrielBursztyn 6/4/2012 21:00'!
addToUnitDenominator: aMeasureUnitCompound
	self subclassResponsibility.! !

!MeasureUnit methodsFor: 'as yet unclassified' stamp: 'GabrielBursztyn 6/4/2012 21:00'!
addToUnitNumerator: aMeasureUnitCompound
	self subclassResponsibility.! !

!MeasureUnit methodsFor: 'as yet unclassified' stamp: 'GabrielBursztyn 6/4/2012 20:51'!
convert: anAmount from: aMeasureUnit
	self subclassResponsibility.! !

!MeasureUnit methodsFor: 'as yet unclassified' stamp: 'GabrielBursztyn 6/4/2012 20:52'!
convertToBaseUnit: aValue
	self subclassResponsibility.! !

!MeasureUnit methodsFor: 'as yet unclassified' stamp: 'GabrielBursztyn 6/5/2012 12:31'!
convertToThisUnitFromBaseUnit: aValue
	self subclassResponsibility.! !

!MeasureUnit methodsFor: 'as yet unclassified' stamp: 'GabrielBursztyn 6/5/2012 12:40'!
hash
	^name hash.
	

! !

!MeasureUnit methodsFor: 'as yet unclassified' stamp: 'GabrielBursztyn 6/5/2012 11:51'!
isEmpty
	self subclassResponsibility.! !

!MeasureUnit methodsFor: 'as yet unclassified' stamp: 'GabrielBursztyn 6/4/2012 20:52'!
printOn: aStream
		self subclassResponsibility.! !

!MeasureUnit methodsFor: 'as yet unclassified' stamp: 'GabrielBursztyn 6/4/2012 20:52'!
type
		self subclassResponsibility.! !

MeasureUnit subclass: #MeasureUnitCompound
	instanceVariableNames: 'numerator denominator'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'EjerciciosPoo-Measure'!

!MeasureUnitCompound class methodsFor: 'as yet unclassified' stamp: 'GabrielBursztyn 6/4/2012 20:49'!
newWith: aMeasureUnit by: anotherMeasureUnit
	^self new initializeWith:  aMeasureUnit by: anotherMeasureUnit ! !

!MeasureUnitCompound class methodsFor: 'as yet unclassified' stamp: 'GabrielBursztyn 6/4/2012 20:49'!
newWith: aMeasureUnit per: anotherMeasureUnit
	^self new initializeWith:  aMeasureUnit per: anotherMeasureUnit ! !

!MeasureUnitCompound methodsFor: 'as yet unclassified' stamp: 'GabrielBursztyn 6/5/2012 00:50'!
= aMeasureUnit
	^[^(aMeasureUnit equalsNumerator: (numerator)) and: (aMeasureUnit equalsDenominator: ( denominator))] on: [Error] do:[^false].! !

!MeasureUnitCompound methodsFor: 'as yet unclassified' stamp: 'GabrielBursztyn 6/5/2012 12:07'!
addToDenominator: aMeasureUnitSimple
	| numeratorWithoutTheUnit |

	denominator add: aMeasureUnitSimple.
	numeratorWithoutTheUnit := numerator select: [: aUnit | aUnit=aMeasureUnitSimple].
	(numeratorWithoutTheUnit size > 0) ifTrue: [ numerator remove: aMeasureUnitSimple.
		denominator remove: aMeasureUnitSimple.
		].! !

!MeasureUnitCompound methodsFor: 'as yet unclassified' stamp: 'GabrielBursztyn 6/5/2012 12:08'!
addToNumerator: aMeasureUnitSimple
	| denominatorWithoutTheUnit |

	numerator add: aMeasureUnitSimple.
	denominatorWithoutTheUnit := denominator select:  [: aUnit |  aUnit=aMeasureUnitSimple].
	(denominatorWithoutTheUnit size >0) ifTrue: [ denominator remove: aMeasureUnitSimple.
		numerator remove: aMeasureUnitSimple.
		].
	
	
	! !

!MeasureUnitCompound methodsFor: 'as yet unclassified' stamp: 'GabrielBursztyn 6/4/2012 21:11'!
addToUnitDenominator: aMeasureUnitCompound
	denominator do: [: aMeasureUnit | aMeasureUnitCompound addToNumerator: aMeasureUnit ].
	numerator do: [: aMeasureUnit | aMeasureUnitCompound addToDenominator: aMeasureUnit ].
! !

!MeasureUnitCompound methodsFor: 'as yet unclassified' stamp: 'GabrielBursztyn 6/4/2012 21:10'!
addToUnitNumerator: aMeasureUnitCompound
	numerator do: [: aMeasureUnit | aMeasureUnitCompound addToNumerator: aMeasureUnit ].
	denominator do: [: aMeasureUnit | aMeasureUnitCompound addToDenominator: aMeasureUnit ].

! !

!MeasureUnitCompound methodsFor: 'as yet unclassified' stamp: 'GabrielBursztyn 6/5/2012 12:31'!
convert: anAmount from: aMeasureUnit
	| baseValue |

	baseValue := (aMeasureUnit convertToBaseUnit: anAmount).
	baseValue := self convertToThisUnitFromBaseUnit: baseValue.

	^Measure newWith:  baseValue unit: self! !

!MeasureUnitCompound methodsFor: 'as yet unclassified' stamp: 'GabrielBursztyn 6/4/2012 21:56'!
convertToBaseUnit: aValue
	| value |
	value := aValue.
	numerator do:[:aMeasureUnit | 
		value := aMeasureUnit convertToBaseUnit: value.
		].
	denominator do:[:aMeasureUnit | 
		value := aMeasureUnit convertToBaseUnit: value.
		].
	^value.

! !

!MeasureUnitCompound methodsFor: 'as yet unclassified' stamp: 'GabrielBursztyn 6/5/2012 12:31'!
convertToThisUnitFromBaseUnit: aValue
	| baseValue |
	baseValue := aValue.
	numerator do: [:aUnit | baseValue:= aUnit convertToThisUnitFromBaseUnit: baseValue. ].
	denominator do: [:aUnit | baseValue:= aUnit convertToThisUnitFromBaseUnit: baseValue. ].
	^baseValue.
! !

!MeasureUnitCompound methodsFor: 'as yet unclassified' stamp: 'GabrielBursztyn 6/5/2012 12:40'!
equalsDenominator: aBagOfUnits
	^ denominator = aBagOfUnits.
	

! !

!MeasureUnitCompound methodsFor: 'as yet unclassified' stamp: 'GabrielBursztyn 6/5/2012 00:50'!
equalsNumerator: aBagOfUnits
	^ numerator = aBagOfUnits.! !

!MeasureUnitCompound methodsFor: 'as yet unclassified' stamp: 'GabrielBursztyn 6/5/2012 11:44'!
initializeWith: aMeasureUnit by: anotherMeasureUnit
	numerator:= Bag new.
	denominator:=Bag new.
	aMeasureUnit addToUnitNumerator: self.
	anotherMeasureUnit addToUnitDenominator:  self.
	! !

!MeasureUnitCompound methodsFor: 'as yet unclassified' stamp: 'GabrielBursztyn 6/4/2012 21:00'!
initializeWith: aMeasureUnit per: anotherMeasureUnit
	numerator:= Bag new.
	denominator:=Bag new.
	aMeasureUnit addToUnitNumerator: self.
	anotherMeasureUnit addToUnitNumerator: self.
	! !

!MeasureUnitCompound methodsFor: 'accessing' stamp: 'GabrielBursztyn 6/5/2012 11:51'!
isEmpty
	^(numerator size = 0) and: (denominator size = 0).! !

!MeasureUnitCompound methodsFor: 'as yet unclassified' stamp: 'GabrielBursztyn 6/5/2012 12:30'!
printOn: aStream

	numerator do: [: aMeasureUnit | aStream nextPutAll: (aMeasureUnit printString)].
	denominator size>0 ifTrue: 
	[aStream nextPutAll:  ' by '.
	denominator do:  [: aMeasureUnit | aStream nextPutAll: (aMeasureUnit printString)]].
	! !

!MeasureUnitCompound methodsFor: 'as yet unclassified' stamp: 'GabrielBursztyn 6/5/2012 12:34'!
type
	| numeratorTypes denominatorTypes types |
	
	numeratorTypes := Set new.
	numerator do: [: aUnit |  numeratorTypes add: (aUnit type) ].
	denominatorTypes := Set new.
	denominator do: [: aUnit |  denominatorTypes add: (aUnit type) ].

	^ (numeratorTypes do: [:aType | ^aType printString]) , ' by ',  
		denominatorTypes do: [:aType | ^aType printString].
! !

MeasureUnit subclass: #MeasureUnitSimple
	instanceVariableNames: 'name amountBaseToThisUnit formulaToBase typeOfUnit'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'EjerciciosPoo-Measure'!

!MeasureUnitSimple class methodsFor: 'as yet unclassified' stamp: 'GabrielBursztyn 6/4/2012 16:44'!
celsius
	^self new: 'celsius' type: 'temperature' applyToBase: [:amount | amount +273] applyFromBase:[:amountBase | amountBase-273].! !

!MeasureUnitSimple class methodsFor: 'as yet unclassified' stamp: 'Satelier 6/3/2012 14:25'!
centimeter
	^self new: 'centimeter' type: 'distance' applyToBase: [:amount | amount * 10] applyFromBase: [:amountBase | amountBase / 10].! !

!MeasureUnitSimple class methodsFor: 'as yet unclassified' stamp: 'Satelier 6/3/2012 14:26'!
day
	^self new: 'day' type: 'time' applyToBase: [:amount | amount * 86400] applyFromBase: [:amountBase | amountBase / 86400].! !

!MeasureUnitSimple class methodsFor: 'as yet unclassified' stamp: 'Satelier 6/3/2012 14:25'!
decameter
	^self new: 'decameter' type: 'distance' applyToBase: [:amount | amount * 10000] applyFromBase: [:amountBase | amountBase / 10000].! !

!MeasureUnitSimple class methodsFor: 'as yet unclassified' stamp: 'Satelier 6/3/2012 14:25'!
decimeter
	^self new: 'decimeter' type: 'distance' applyToBase: [:amount | amount * 100] applyFromBase: [:amountBase | amountBase / 100].! !

!MeasureUnitSimple class methodsFor: 'as yet unclassified' stamp: 'GabrielBursztyn 6/4/2012 16:45'!
fahrenheit
	^self new: 'fahrenheit' type: 'temperature' applyToBase: [:amount | (amount -32) * 5/9+273] applyFromBase: [:amountBase | (amountBase-273) / (5/9) + 32].! !

!MeasureUnitSimple class methodsFor: 'as yet unclassified' stamp: 'Satelier 6/3/2012 14:25'!
hectometer
	^self new: 'hectometer' type: 'distance' applyToBase: [:amount | amount * 100000] applyFromBase: [:amountBase | amountBase / 100000].! !

!MeasureUnitSimple class methodsFor: 'as yet unclassified' stamp: 'Satelier 6/3/2012 14:26'!
hour
	^self new: 'hour' type: 'time' applyToBase: [:amount | amount * 3600] applyFromBase: [:amountBase | amountBase / 3600].! !

!MeasureUnitSimple class methodsFor: 'as yet unclassified' stamp: 'GabrielBursztyn 6/4/2012 16:44'!
kelvin
	^self new: 'kelvin' type: 'temperature' applyToBase: [:amount | amount ] applyFromBase: [:amountBase | amountBase].! !

!MeasureUnitSimple class methodsFor: 'as yet unclassified' stamp: 'Satelier 6/3/2012 14:26'!
kilometer
	^self new: 'kilometer' type: 'distance' applyToBase: [:amount | amount * 1000000] applyFromBase: [:amountBase | amountBase / 1000000].! !

!MeasureUnitSimple class methodsFor: 'as yet unclassified' stamp: 'Satelier 6/3/2012 14:26'!
meter
	^self new: 'meter' type: 'distance' applyToBase: [:amount | amount * 1000] applyFromBase: [:amountBase | amountBase / 1000].! !

!MeasureUnitSimple class methodsFor: 'as yet unclassified' stamp: 'Satelier 6/3/2012 14:26'!
milimeter
	^self new: 'milimeter' type: 'distance' applyToBase: [:amount | amount] applyFromBase: [:amountBase | amountBase].! !

!MeasureUnitSimple class methodsFor: 'as yet unclassified' stamp: 'Satelier 6/3/2012 14:26'!
minute
	^self new: 'minute' type: 'time' applyToBase: [:amount | amount * 60] applyFromBase: [:amountBase | amountBase / 60].! !

!MeasureUnitSimple class methodsFor: 'as yet unclassified' stamp: 'Satelier 6/3/2012 14:23'!
new: aName type: aType applyToBase: aFormulaToBase applyFromBase: aFormulaFromBase
	^self new initializeWith: aName type: aType applyToBase: aFormulaToBase applyFromBase: aFormulaFromBase.! !

!MeasureUnitSimple class methodsFor: 'as yet unclassified' stamp: 'Satelier 6/3/2012 14:26'!
second
	^self new: 'second' type: 'time' applyToBase: [:amount | amount] applyFromBase: [:amountBase | amountBase].! !

!MeasureUnitSimple methodsFor: 'as yet unclassified' stamp: 'GabrielBursztyn 6/4/2012 22:08'!
= aMeasureUnit
^	[^(aMeasureUnit isKindOf: self class) and: 	(self printString = aMeasureUnit printString ) and: (self type = aMeasureUnit type).] on: [Error ] do: [^false.]

! !

!MeasureUnitSimple methodsFor: 'as yet unclassified' stamp: 'Satelier 6/3/2012 16:53'!
adaptToNumber: aNumber andSend: selector
	^(Measure newWith: 1 unit: self)   perform: selector with: aNumber! !

!MeasureUnitSimple methodsFor: 'as yet unclassified' stamp: 'GabrielBursztyn 6/4/2012 21:01'!
addToUnitDenominator: aMeasureUnitCompound
	aMeasureUnitCompound addToDenominator: self.! !

!MeasureUnitSimple methodsFor: 'as yet unclassified' stamp: 'GabrielBursztyn 6/4/2012 21:00'!
addToUnitNumerator: aMeasureUnitCompound
	aMeasureUnitCompound addToNumerator: self.! !

!MeasureUnitSimple methodsFor: 'as yet unclassified' stamp: 'GabrielBursztyn 6/4/2012 21:56'!
convert: anAmount from: aMeasureUnit
	| baseValue |

	baseValue := (aMeasureUnit convertToBaseUnit: anAmount).
	^Measure newWith:  (amountBaseToThisUnit value: baseValue) unit: self! !

!MeasureUnitSimple methodsFor: 'as yet unclassified' stamp: 'GabrielBursztyn 6/4/2012 20:52'!
convertToBaseUnit: aValue

	^formulaToBase value: aValue.! !

!MeasureUnitSimple methodsFor: 'as yet unclassified' stamp: 'GabrielBursztyn 6/5/2012 12:31'!
convertToThisUnitFromBaseUnit: aValue

	^amountBaseToThisUnit value: aValue.! !

!MeasureUnitSimple methodsFor: 'as yet unclassified' stamp: 'Satelier 6/3/2012 14:31'!
initializeWith: aName type: aType applyToBase: aFormulaToBase applyFromBase: aFormulaFromBase
	name:=aName.
	typeOfUnit:= aType.
	formulaToBase:=aFormulaToBase.
	amountBaseToThisUnit := aFormulaFromBase.
! !

!MeasureUnitSimple methodsFor: 'as yet unclassified' stamp: 'GabrielBursztyn 6/5/2012 11:51'!
isEmpty
	^false.! !

!MeasureUnitSimple methodsFor: 'as yet unclassified' stamp: 'GabrielBursztyn 5/22/2012 01:11'!
printOn: aStream
	aStream nextPutAll: name.! !

!MeasureUnitSimple methodsFor: 'as yet unclassified' stamp: 'Satelier 6/3/2012 14:27'!
type
	^typeOfUnit.! !
